<?php
/*
Plugin Name: Ada A Blog Recent Posts
Plugin URI: http://1uthavi.adadaa.com/ada-a-blog-recent-posts-widget/
Description: Adds a sidebar widget to let you display recent Posts from a single blog.  Directly accesses the DB instead of RSS.
Author: CAPitalZ
Version: 0.1.2
Author URI: http://adadaa.com/
*/

function ada_a_blog_recent_posts_init() {

//global $configure_word_limit;

require_once(dirname(__FILE__) . "/ada_a_blog.php");

$widget_title = "Adadaa News";	// Change this to name the widget
//$configure_word_limit = '0';			//Change as you like

	// This widget depends on the Ada List-All-Posts plugin
	if ( !function_exists('ada_list_all_posts_from_a_blog') )
		return;

	function widget_aablogposts($args) {
	 
		//global $configure_word_limit;
		
		extract($args);

		$options = get_option('widget_aablogposts');
		$title = $options['title'];
		$blgid = $options['blgid'];
		$limit = abs($options['limit']);
		//hard coded values		
		//$begin_wrap = '<p>';
		//$end_wrap = '</p>';
		//$title_begin_wrap = '<p>';	
		//$title_end_wrap = '</p>';
		//$read_more = $options['read_more'];
		$word_limit = abs($options['word_limit']);
		//$word_limit = $configure_word_limit;
		$begin_wrap = '<ul>';
		$end_wrap = '</ul>';		
		$title_begin_wrap = '<li>';	
		$title_end_wrap = '</li>';		
		//$read_more = "hide";
		$read_more = $options['read_more'];
		//$show_author = "hide";
		$show_author = $options['show_author'];
		$post_type = $options['post_type'];
		//$post_type = "post";	//change this to "page" if you want to display recent pages		

		echo $before_widget . $before_title . $title . $after_title;
		$all_posts = ada_list_all_posts_from_a_blog($limit, $word_limit, $begin_wrap, $end_wrap, $title_begin_wrap, $title_end_wrap, $read_more, $show_author, $show_blog, $post_type, $blgid);

		if($all_posts){
			ada_echoArrayABlogPostList($all_posts);	//eliminates the PHP warning, if there is only one blog in the entire site
		}
		
		echo $after_widget;

	}

	function widget_aablogposts_control() {

		$options = get_option('widget_aablogposts');
		if ( !is_array($options) )
			$options = array('title'=>'Star Blog Posts', 'limit'=>'10', 'word_limit'=>'0', 'read_more'=>'hide', 'show_author'=>'hide', 'post_type'=>'post');


		if ( $_POST['aablogposts-submit'] ) {

			// Remember to sanitize and format use input appropriately.
			$options['title'] = strip_tags(stripslashes($_POST['aablogposts-title']));
			$options['blgid'] = strip_tags(stripslashes($_POST['aablogposts-blgid']));
			$options['limit'] = strip_tags(stripslashes($_POST['aablogposts-limit']));
			$options['word_limit'] = strip_tags(stripslashes($_POST['aablogposts-word_limit']));
			$options['read_more'] = strip_tags(stripslashes($_POST['aablogposts-read_more']));
			$options['show_author'] = strip_tags(stripslashes($_POST['aablogposts-show_author']));
			$options['post_type'] = strip_tags(stripslashes($_POST['aablogposts-post_type']));
			update_option('widget_aablogposts', $options);
		}

		// Be sure you format your options to be valid HTML attributes.
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$blgid = htmlspecialchars($options['blgid'], ENT_QUOTES);
		$limit = htmlspecialchars($options['limit'], ENT_QUOTES);
		$word_limit = htmlspecialchars($options['word_limit'], ENT_QUOTES);
		$read_more = htmlspecialchars($options['read_more'], ENT_QUOTES);
		$show_author = htmlspecialchars($options['show_author'], ENT_QUOTES);
		$post_type = htmlspecialchars($options['post_type'], ENT_QUOTES);
		
		// Here is our little form segment. Notice that we don't need a
		// complete form. This will be embedded into the existing form.
		echo '<p style="text-align:right;"><label for="aablogposts-title">' . __('Title:') . ' <input style="width: 200px;" id="aablogposts-title" name="aablogposts-title" type="text" value="'.$title.'" /></label></p>';
		
		echo '<p style="text-align:right;"><label for="aablogposts-blgid">' . __('Blog ID:') . ' <input style="width: 200px;" id="aablogposts-blgid" name="aablogposts-blgid" type="text" value="'.$blgid.'" /></label></p>';

		echo '<p style="text-align:right;"><label for="aablogposts-limit">' . __('Limit:', 'widgets') . ' <input style="width: 200px;" id="aablogposts-limit" name="aablogposts-limit" type="text" value="'.$limit.'" /></label></p>';
		/* If commented above line and uncommented this code,
			widget will display a pull down menu for limit with 1 to 10 options

		echo '<p style="text-align:right;"><label for="aablogposts-limit">' . __('Limit:', 'widgets') . ' <select style="width: 200px;" id="aablogposts-limit" name="ablogs-limit">';
			echo '<option value="1" ';
			if($limit=='1') { echo 'selected="selected"'; }
			echo '>1</option><option value="2" ';
		    if($limit=='2') { echo 'selected="selected"';}
		    echo '>2</option><option value="3" ';
		    if($limit=='3') { echo 'selected="selected"';}
			echo '>3</option><option value="4" ';
			if($limit=='4') { echo 'selected="selected"';}
			echo '>4</option><option value="5" ';
			if($limit=='5') { echo 'selected="selected"';}
			echo '>5</option><option value="6" ';
			if($limit=='6') { echo 'selected="selected"';}
			echo '>6</option><option value="7" ';
			if($limit=='7') { echo 'selected="selected"';}
			echo '>7</option><option value="8" ';
			if($limit=='8') { echo 'selected="selected"';}
			echo '>8</option><option value="9" ';
			if($limit=='9') { echo 'selected="selected"';}
			echo '>9</option><option value="10" ';
			if($limit=='10') { echo 'selected="selected"';}
			echo '>10</option></select></label></p>';
		*/
		
		echo '<p style="text-align:right;"><label for="aablogposts-word_limit">' . __('Word Limit:', 'widgets') . ' <input style="width: 100px;" id="aablogposts-word_limit" name="aablogposts-word_limit" type="text" value="'.$word_limit.'" /></label></p>';
		echo '<p style="text-align:right;"><label for="aablogposts-read_more">' . __('Read More:', 'widgets') . ' <select style="width: 100px;" id="aablogposts-read_more" name="aablogposts-read_more">';
			echo '<option value="show" ';
			if($read_more=='show') { echo 'selected="selected"';}
			echo '>Show</option><option value="hide"';
			if($read_more=='hide') { echo 'selected="selected"';}
			echo '>Hide</option></select></label></p>';

		echo '<p style="text-align:right;"><label for="aablogposts-show_author">' . __('Author:', 'widgets') . ' <select style="width: 100px;" id="aablogposts-show_author" name="aablogposts-show_author">';
			echo '<option value="show" ';
			if($show_author=='show') { echo 'selected="selected"';}
			echo '>Show</option><option value="hide"';
			if($show_author=='hide') { echo 'selected="selected"';}
			echo '>Hide</option></select></label></p>';

		echo '<p style="text-align:right;"><label for="aablogposts-post_type">' . __('Post Type:', 'widgets') . ' <select style="width: 100px;" id="aablogposts-post_type" name="aablogposts-post_type">';
			echo '<option value="post" ';
			if($post_type=='post') { echo 'selected="selected"';}
			echo '>Post</option><option value="page"';
			if($post_type=='page') { echo 'selected="selected"';}
			echo '>Page</option></select></label></p>';

		echo '<input type="hidden" id="aablogposts-submit" name="aablogposts-submit" value="1" />';
	}
	
	register_sidebar_widget(array($widget_title, 'widgets'), 'widget_aablogposts');

	register_widget_control(array($widget_title, 'widgets'), 'widget_aablogposts_control', 300, 275);
}

add_action('widgets_init', 'ada_a_blog_recent_posts_init');

?>